proc MAIN {{cpu_type NO_MMU} {TSE 0} {cache_size "_32768"}} {
	#mem map
	set mem_map(ddr2_top) "0x0000";
	set mem_map(peripheral_pipeline_bridge) "0x18000000";
	set mem_map(high_peripheral_pipeline_bridge) "0x40000000";
	set mem_map(fsm_pipeline_bridge) "0x10000000";
	set mem_map(tlb_tcm) "0x0e100000";
	set mem_map(jtag_debug_module) "0x0e000000";          
	set mem_map(tse_pipeline_bridge) "0x1a000000";
	
	set irq_map(timer_1ms) 1;
	set irq_map(dipsw_pio) 5;
	set irq_map(button_pio) 4;
	set irq_map(dma_0) 8;
	set irq_map(uart) 2;
	set irq_map(jtag_uart) 3;
	set irq_map(tx_sgdma) 6;
	set irq_map(rx_sgdma) 7;
	
	#create the system
	
	create_system                                    
	set system_name "niosII_cycloneIII_3c120_host_board_sopc";
	set_system_name $system_name;
	
	## System Parameters
#	set_system_parameter bonusData "bonusData \n{\n   element tlb_tcm.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"235929600\";\n         type = \"long\";\n      }\n   }\n   element ddr2_top\n   {\n      datum _sortIndex\n      {\n         value = \"2\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element ddr2_top.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element dma_0.control_port_slave\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"512\";\n         type = \"long\";\n      }\n   }\n   element ext_flash.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"0\";\n         type = \"long\";\n      }\n   }\n   element jtag_uart.avalon_jtag_slave\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"448\";\n         type = \"long\";\n      }\n   }\n   element cpu.instruction_master\n   {\n      datum color\n      {\n         value = \"-65485\";\n         type = \"int\";\n      }\n   }\n   element fsm_pipeline_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"14\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element dipsw_pio\n   {\n      datum _sortIndex\n      {\n         value = \"6\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element sgdma_rx_desc_pipeline_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"18\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element sgdma_tx.csr\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"1024\";\n         type = \"long\";\n      }\n   }\n   element sgdma_rx.csr\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element pipeline_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"25\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element fsm_tristate_bridge.avalon_slave\n   {\n      datum baseAddress\n      {\n         value = \"0\";\n         type = \"long\";\n      }\n   }\n   element sgdma_rx\n   {\n      datum _sortIndex\n      {\n         value = \"17\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element tse_clock_crossing_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"19\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element ssg_aim_half_rate_adapter_0\n   {\n      datum _sortIndex\n      {\n         value = \"1\";\n         type = \"int\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element high_peripheral_pipeline_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"1073741824\";\n         type = \"long\";\n      }\n   }\n   element tlb_tcm.s2\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"235929600\";\n         type = \"long\";\n      }\n   }\n   element sgdma_tx_pipeline_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"0\";\n         type = \"long\";\n      }\n   }\n   element peripheral_pipeline_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"15\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element niosII_cycloneIII_3c120_host_board_sopc\n   {\n   }\n   element timer_1ms\n   {\n      datum _sortIndex\n      {\n         value = \"5\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element cpu.jtag_debug_module\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"234881024\";\n         type = \"long\";\n      }\n   }\n   element jtag_uart\n   {\n      datum _sortIndex\n      {\n         value = \"11\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element button_pio.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"320\";\n         type = \"long\";\n      }\n   }\n   element fsm_tristate_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"12\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element tse_clock_crossing_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"236978176\";\n         type = \"long\";\n      }\n   }\n   element cpu\n   {\n      datum _sortIndex\n      {\n         value = \"3\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element led_pio\n   {\n      datum _sortIndex\n      {\n         value = \"8\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element sgdma_tx_pipeline_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"21\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element tse_mac.control_port\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"236980224\";\n         type = \"long\";\n      }\n   }\n   element dma_0\n   {\n      datum _sortIndex\n      {\n         value = \"9\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element fsm_pipeline_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"268435456\";\n         type = \"long\";\n      }\n   }\n   element peripheral_pipeline_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"402653184\";\n         type = \"long\";\n      }\n   }\n   element ssg_aim_half_rate_adapter_0.avalon_slave\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element tse_mac\n   {\n      datum _sortIndex\n      {\n         value = \"24\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element led_pio.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"384\";\n         type = \"long\";\n      }\n   }\n   element timer_1ms.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"0\";\n         type = \"long\";\n      }\n   }\n   element dipsw_pio.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"256\";\n         type = \"long\";\n      }\n   }\n   element sgdma_tx\n   {\n      datum _sortIndex\n      {\n         value = \"20\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element sgdma_rx_desc_pipeline_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"0\";\n         type = \"long\";\n      }\n   }\n   element ext_flash\n   {\n      datum _sortIndex\n      {\n         value = \"13\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element clk\n   {\n      datum _sortIndex\n      {\n         value = \"0\";\n         type = \"int\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element tlb_tcm\n   {\n      datum _sortIndex\n      {\n         value = \"4\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n   }\n   element rx_adapter\n   {\n      datum _sortIndex\n      {\n         value = \"22\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element uart.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"128\";\n         type = \"long\";\n      }\n   }\n   element tx_adapter\n   {\n      datum _sortIndex\n      {\n         value = \"23\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element pipeline_bridge.s1\n   {\n      datum _lockedAddress\n      {\n         value = \"1\";\n         type = \"boolean\";\n      }\n      datum baseAddress\n      {\n         value = \"0\";\n         type = \"long\";\n      }\n   }\n   element button_pio\n   {\n      datum _sortIndex\n      {\n         value = \"7\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element uart\n   {\n      datum _sortIndex\n      {\n         value = \"10\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n   element high_peripheral_pipeline_bridge\n   {\n      datum _sortIndex\n      {\n         value = \"16\";\n         type = \"int\";\n      }\n      datum megawizard_uipreferences\n      {\n         value = \"{}\";\n         type = \"String\";\n      }\n      datum sopceditor_expanded\n      {\n         value = \"0\";\n         type = \"boolean\";\n      }\n   }\n}\n"
	set_system_parameter deviceFamily "CYCLONEIII"
	set_system_parameter generateLegacySim "false"
	set_system_parameter hardcopyCompatible "false"
	set_system_parameter hdlLanguage "VERILOG"
	set_system_parameter projectName "niosII_cycloneIII_3c120_host_board_top.qpf"

	#add components
	#clk
	add_module clock_source clk
	set_parameter clk clockFrequency "50000000"
	set_parameter clk clockFrequencyKnown "true"
	
	#ddr2
	add_hp_ddr2 clk.clk "Half";
	
	set sysclk ddr2_top.sysclk;
	
	#peripherals                       
	puts "Adding Main Peripherals";
	array set peripheral_pipeline_bridge [add_peripheral_pipeline_bridge_and_components $sysclk];
	puts "Adding High Mem Peripherals";
	array set high_peripheral_pipeline_bridge [add_high_peripheral_pipeline_bridge_and_components $sysclk];
	puts "Adding Flash Peripherals";
	array set ext_flash [add_flash $sysclk];
	
	#tcm
	add_tlb_tcm $sysclk tlb_tcm;
	

	
	#cpu
	add_cpu $sysclk $cache_size;
	change_cpu_type cpu $cpu_type;
	
	#connect CPU to memories
	add_connection cpu.instruction_master/ddr2_top.s1;
	add_connection cpu.data_master/ddr2_top.s1;
	set_parameter cpu.instruction_master/ddr2_top.s1 baseAddress $mem_map(ddr2_top);
	set_parameter cpu.data_master/ddr2_top.s1 baseAddress $mem_map(ddr2_top);
	set_parameter cpu.instruction_master/ddr2_top.s1 arbitrationPriority "1";
	set_parameter cpu.data_master/ddr2_top.s1 arbitrationPriority "1";
	
	#cpu tlb tcm                                    
	add_connection $sysclk/tlb_tcm.clk1;
	add_connection $sysclk/tlb_tcm.clk2;
	add_connection cpu.tightly_coupled_instruction_master_0/tlb_tcm.s1;
	add_connection cpu.tightly_coupled_data_master_0/tlb_tcm.s2;
	set_parameter cpu.tightly_coupled_instruction_master_0/tlb_tcm.s1 baseAddress $mem_map(tlb_tcm);
	set_parameter cpu.tightly_coupled_data_master_0/tlb_tcm.s2 baseAddress $mem_map(tlb_tcm);
	set_parameter cpu.tightly_coupled_instruction_master_0/tlb_tcm.s1 arbitrationPriority "1";
	set_parameter cpu.tightly_coupled_data_master_0/tlb_tcm.s2 arbitrationPriority "1";
	        
	#cpu debug
	add_connection cpu.data_master/cpu.jtag_debug_module
	set_parameter cpu.data_master/cpu.jtag_debug_module baseAddress $mem_map(jtag_debug_module);
	set_parameter cpu.data_master/cpu.jtag_debug_module arbitrationPriority "1";
	add_connection cpu.instruction_master/cpu.jtag_debug_module
	set_parameter cpu.instruction_master/cpu.jtag_debug_module baseAddress $mem_map(jtag_debug_module);
	set_parameter cpu.instruction_master/cpu.jtag_debug_module arbitrationPriority "1";
	
	#hookup cpu to bridges                             
	#puts  [get_component_array_port_type peripheral_pipeline_bridge interrupt_sender]
	foreach irq [get_component_array_port_type peripheral_pipeline_bridge interrupt_sender] {
	#	puts $irq;
		add_connection cpu.d_irq/$irq;
		set_parameter cpu.d_irq/$irq irqNumber $irq_map([lindex [split $irq "."] 0]);
	}
	
	
	foreach slave [get_component_array_port_type peripheral_pipeline_bridge avalon_slave] {
		add_connection cpu.data_master/$slave;
		set_parameter cpu.data_master/$slave baseAddress $mem_map([lindex [split $slave "."] 0]);
		set_parameter cpu.data_master/$slave arbitrationPriority "1";
	}

	foreach slave [get_component_array_port_type high_peripheral_pipeline_bridge avalon_slave] {
		add_connection cpu.data_master/$slave;
		set_parameter cpu.data_master/$slave baseAddress $mem_map([lindex [split $slave "."] 0]);
		set_parameter cpu.data_master/$slave arbitrationPriority "1";
	}
	
	
	foreach slave [get_component_array_port_type ext_flash avalon_slave] {
		add_connection cpu.data_master/$slave;
		set_parameter cpu.data_master/$slave baseAddress $mem_map([lindex [split $slave "."] 0]);
		set_parameter cpu.data_master/$slave arbitrationPriority "1";  
		add_connection cpu.instruction_master/$slave;
		set_parameter cpu.instruction_master/$slave baseAddress $mem_map([lindex [split $slave "."] 0]);
		set_parameter cpu.instruction_master/$slave arbitrationPriority "1";  
	}                                                                          
	                                             
	#connect dma to ddr
	foreach master [get_component_array_port_type peripheral_pipeline_bridge avalon_master] {
		add_connection $master/ddr2_top.s1;
		set_parameter $master/ddr2_top.s1 baseAddress $mem_map(ddr2_top);
		set_parameter $master/ddr2_top.s1 arbitrationPriority "1";
	}
	
	
	#tse
	if {$TSE} {
		array set tse_components [add_tse_components $sysclk];
		
		#connect TSE to DDR
		foreach master [get_component_array_port_type tse_components avalon_master] {
			add_connection $master/ddr2_top.s1;
			set_parameter $master/ddr2_top.s1 baseAddress $mem_map(ddr2_top);
			set_parameter $master/ddr2_top.s1 arbitrationPriority "1";
		}
		#connect CPU to TSE
		foreach slave [get_component_array_port_type tse_components avalon_slave] {
			add_connection cpu.data_master/$slave;
			set_parameter cpu.data_master/$slave baseAddress $mem_map([lindex [split $slave "."] 0]);
			set_parameter cpu.data_master/$slave arbitrationPriority "1";
		}                  
		#connect TSE irqs to CPU
		foreach irq [get_component_array_port_type tse_components interrupt_sender] {
		#	puts $irq;
			add_connection cpu.d_irq/$irq;
			set_parameter cpu.d_irq/$irq irqNumber $irq_map([lindex [split $irq "."] 0]);
		}
	}
	
	#some cpu conf stuff                                         
	set_parameter cpu resetSlave "ext_flash.s1"
	set_parameter cpu resetOffset "29360128"
	set_parameter cpu exceptionSlave "ddr2_top.s1"
	set_parameter cpu exceptionOffset "32"
	
	save_system $system_name;
}

proc add_tse_components {clock} { 
	
	
	
	#tse behind bridge with sgdmas
	set mem_map(tse_mac) "0x0"
	set mem_map(tx_sgdma) "0x400"
	set mem_map(rx_sgdma) "0x800"
	
	#add bridge for tse copmonents
	set bridge_components(tse_pipeline_bridge) [add_pipeline_bridge tse_pipeline_bridge 32];

	#add bridge for sgdma desc masters
	set bridge_components(tx_sgdma_desc_pipeline_bridge) [add_pipeline_bridge tx_sgdma_desc_pipeline_bridge 32];
	set bridge_components(rx_sgdma_desc_pipeline_bridge) [add_pipeline_bridge rx_sgdma_desc_pipeline_bridge 32];
	              
	#puts $bridge_components_list;
	#array set bridge_components $bridge_components_list;
	
	#add tx_sgdma	
	set tx_sgdma(class) altera_avalon_sgdma;
	set comp_params(enableBurstTransfers) "false";
	set comp_params(internalFIFODepth) "2";
	set comp_params(transferMode) "MEMORY_TO_STREAM";
	set comp_params(sinkErrorWidth) "0";
	set comp_params(writeBurstcountWidth) "4";
	set comp_params(addressWidth) "32";
	set comp_params(readBlockDataWidth) "32";
	set comp_params(sourceErrorWidth) "1";
	set comp_params(readBurstcountWidth) "4";
	set comp_params(dataTransferFIFODepth) "2";
	set comp_params(enableUnalignedTransfers) "false";
	set comp_params(alwaysDoMaxBurst) "true";
	set comp_params(enableDescriptorReadMasterBurst) "false";
	set tx_sgdma(parameters) [array get comp_params];  
	array unset comp_params;
	set tx_sgdma(ports) [list avalon_slave [list csr] clock_sink [list clk] avalon_master [list m_read descriptor_read descriptor_write] avalon_streaming_source [list out] interrupt_sender [list csr_irq]];
	
	set components(tx_sgdma) [array get tx_sgdma];
	
	#add rx sgdma
	set rx_sgdma(class) altera_avalon_sgdma;        
	set comp_params(enableBurstTransfers) "false";
	set comp_params(internalFIFODepth) "2";
	set comp_params(transferMode) "STREAM_TO_MEMORY";
	set comp_params(sinkErrorWidth) "6";
	set comp_params(writeBurstcountWidth) "4";
	set comp_params(addressWidth) "32";
	set comp_params(readBlockDataWidth) "32";
	set comp_params(sourceErrorWidth) "0";
	set comp_params(readBurstcountWidth) "4";
	set comp_params(dataTransferFIFODepth) "2";
	set comp_params(enableUnalignedTransfers) "false";
	set comp_params(alwaysDoMaxBurst) "true";
	set comp_params(enableDescriptorReadMasterBurst) "false";
	set rx_sgdma(parameters) [array get comp_params];  
	array unset comp_params;
	set rx_sgdma(ports) [list avalon_slave [list csr] clock_sink [list clk] avalon_master [list m_write descriptor_read descriptor_write] avalon_streaming_sink [list in] interrupt_sender [list csr_irq]];
	
	set components(rx_sgdma) [array get rx_sgdma];
	
	#add tse_mac
	set tse_mac(class) triple_speed_ethernet;
	set comp_params(channel_count) "1"
	set comp_params(core_variation) "MAC_ONLY"
	set comp_params(core_version) "1794"
	set comp_params(crc32check16bit) "0"
	set comp_params(crc32dwidth) "8"
	set comp_params(crc32gendelay) "6"
	set comp_params(crc32s1l2_extern) "false"
	set comp_params(cust_version) "0"
	set comp_params(dataBitsPerSymbol) "8"
	set comp_params(dev_version) "2048"
	set comp_params(deviceFamily) "CYCLONEIII"
	set comp_params(eg_addr) "11"
	set comp_params(ena_hash) "true"
	set comp_params(enable_clk_sharing) "false"
	set comp_params(enable_ena) "32"
	set comp_params(enable_fifoless) "false"
	set comp_params(enable_gmii_loopback) "true"
	set comp_params(enable_hd_logic) "true"
	set comp_params(enable_mac_flow_ctrl) "true"
	set comp_params(enable_mac_txaddr_set) "true"
	set comp_params(enable_mac_vlan) "true"
	set comp_params(enable_maclite) "false"
	set comp_params(enable_magic_detect) "true"
	set comp_params(enable_multi_channel) "false"
	set comp_params(enable_pkt_class) "true"
	set comp_params(enable_pma) "false"
	set comp_params(enable_reg_sharing) "false"
	set comp_params(enable_sgmii) "false"
	set comp_params(enable_shift16) "true"
	set comp_params(enable_sup_addr) "true"
	set comp_params(enable_use_internal_fifo) "true"
	set comp_params(export_calblkclk) "false"
	set comp_params(export_pwrdn) "false"
	set comp_params(gigeAdvanceMode) "true"
	set comp_params(ifGMII) "RGMII"
	set comp_params(ifPCSuseEmbeddedSerdes) "false"
	set comp_params(ing_addr) "11"
	set comp_params(insert_ta) "true"
	set comp_params(maclite_gige) "false"
	set comp_params(max_channels) "0"
	set comp_params(mdio_clk_div) "40"
	set comp_params(phy_identifier) "0"
	set comp_params(ramType) "AUTO"
	set comp_params(reset_level) "1"
	set comp_params(stat_cnt_ena) "true"
	set comp_params(timingAdapterName) "timingAdapter"
	set comp_params(toolContext) "SOPC_BUILDER"
	set comp_params(transceiver_type) "GXB"
	set comp_params(uiMDIOFreq) "3 MHz"
	set comp_params(useLvds) "false"
	set comp_params(useMAC) "true"
	set comp_params(useMDIO) "true"
	set comp_params(usePCS) "false"
	set comp_params(use_sync_reset) "false"     
	set tse_mac(parameters) [array get comp_params];
	array unset comp_params;
	set tse_mac(ports) [list avalon_slave [list control_port] clock_sink [list control_port_clock_connection transmit_clock_connection receive_clock_connection] avalon_streaming_sink [list transmit] avalon_streaming_source [list receive]];
                                  
	set components(tse_mac) [array get tse_mac];
	
	#set components(tse_mac) [array get tse_component];
	
	#array set components $component_list;
	
	#add the components
	add_component_array components;
	#add_component_array bridge_components;

	#connect clocks
	puts "connecting clocks"
	foreach clock_port [get_component_array_port_type components clock_sink] {
		add_connection $clock/$clock_port;
	}
	puts "connection bridge clocks"
	foreach clock_port [get_component_array_port_type bridge_components clock_sink] {
		add_connection $clock/$clock_port;
	}
	
	#connect slaves to tse bridge
	set b_master [get_component_ports_of_type bridge_components tse_pipeline_bridge avalon_master];
	    puts $b_master 
	puts [array get bridge_components];
	foreach slave [get_component_array_port_type components avalon_slave] {
		add_connection $b_master/$slave;
		#add addresses here
		set_parameter $b_master/$slave baseAddress $mem_map([lindex [split $slave "."] 0]);
		set_parameter $b_master/$slave arbitrationPriority "1";
	}
	
	#add sgdma streaming connections
	add_connection [get_component_ports_of_type components tse_mac avalon_streaming_source]/[get_component_ports_of_type components rx_sgdma avalon_streaming_sink];
	add_connection [get_component_ports_of_type components tx_sgdma avalon_streaming_source]/[get_component_ports_of_type components tse_mac avalon_streaming_sink];
	
	#pipeline descriptor mems
	#rx_sgmda
	set b_slave [get_component_ports_of_type bridge_components rx_sgdma_desc_pipeline_bridge avalon_slave];

	foreach master_port [get_component_ports_of_type components rx_sgdma avalon_master] {
		if {[string match *descriptor* $master_port]} {
			set connection $master_port/$b_slave;
			add_connection $connection;
			set_parameter $connection baseAddress "0x000";
			set_parameter $connection arbitrationPriority "1";
		}
	}
	
	#tx_sgdma
	set b_slave [get_component_ports_of_type bridge_components tx_sgdma_desc_pipeline_bridge avalon_slave];

	foreach master_port [get_component_ports_of_type components tx_sgdma avalon_master] {
		if {[string match *descriptor* $master_port]} {
			set connection $master_port/$b_slave;
			add_connection $connection;
			set_parameter $connection baseAddress "0x000";
			set_parameter $connection arbitrationPriority "1";
		}
	}	
	
	#return unconnected avalon interfaces
	set return_ports(tse_pipeline_bridge) [list ports [list avalon_slave [list s1]]];
	set return_ports(rx_sgdma_desc_pipeline_bridge) [list ports [list avalon_master [list m1]]];
	set return_ports(tx_sgdma_desc_pipeline_bridge) [list ports [list avalon_master [list m1]]];
	set return_ports(tx_sgdma) [list ports [list avalon_master [list m_read] interrupt_sender [list csr_irq]]];
	set return_ports(rx_sgdma) [list ports [list avalon_master [list m_write] interrupt_sender [list csr_irq]]];
	
	return [array get return_ports];
}

proc add_flash {clock} {
                                                   
	#flash	                                   
	puts "adding ext_flash"
	set ext_flash(class) altera_avalon_cfi_flash;
	set component_params(addressWidth) "25";
	set component_params(corePreset) "CUSTOM";
	set component_params(dataWidth) "16";
	set component_params(holdTime) "35";
	set component_params(setupTime) "45";              
	set component_params(sharedPorts) "s1/address,s1/data";
	set component_params(timingUnits) "NS";
	set component_params(waitTime) "160";
	set ext_flash(parameters) [array get component_params];
	array unset component_params;
	set ext_flash(ports) [list avalon_slave [list s1] clock_sink [list clk]];
	                                                                        
	add_component ext_flash;
	
	#tri state bridge
	puts "adding fsm_tristate_bridge"
	set fsm_tristate_bridge(class) altera_avalon_tri_state_bridge;
	set fsm_tristate_bridge(ports) [list avalon_master [list tristate_master] clock_sink [list clk] avalon_slave [list avalon_slave]];
	set component_params(registerIncomingSignals) "true";
	set fsm_tristate_bridge(parameters) [array get component_params];
	array unset component_params;
	
	add_component fsm_tristate_bridge;
	
	#fsm pipeline bridge
	puts "adding fsm_pipeline_bridge"
	set fsm_pipeline_bridge(class) altera_avalon_pipeline_bridge;
	set component_params(dataWidth) "32";
	set component_params(maxBurstSize) "2";
	set component_params(waitrequestPipeline) "true";
	set component_params(burstEnable) "false";
	set component_params(downstreamPipeline) "true";
	set component_params(upstreamPipeline) "true";
	set component_params(enableArbiterlock) "false";
	set fsm_pipeline_bridge(parameters) [array get component_params];
	array unset component_params;
	set fsm_pipeline_bridge(ports) [list clock_sink [list clk] avalon_slave [list s1] avalon_master [list m1]];
	                                            
	add_component fsm_pipeline_bridge;                     
	
	#connect everything up    
	add_connection fsm_tristate_bridge.tristate_master/ext_flash.s1;
	set_parameter fsm_tristate_bridge.tristate_master/ext_flash.s1 baseAddress "0x0000";
	set_parameter fsm_tristate_bridge.tristate_master/ext_flash.s1 arbitrationPriority "1";
	
	add_connection fsm_pipeline_bridge.m1/fsm_tristate_bridge.avalon_slave;
	set_parameter fsm_pipeline_bridge.m1/fsm_tristate_bridge.avalon_slave baseAddress "0x0000";
	set_parameter fsm_pipeline_bridge.m1/fsm_tristate_bridge.avalon_slave arbitrationPriority "1";
	
	set component_array(ext_flash) [array get ext_flash];
	set component_array(fsm_pipeline_bridge) [array get fsm_pipeline_bridge];
	set component_array(fsm_tristate_bridge) [array get fsm_tristate_bridge];
	
	#connect clocks
	foreach clk_port [get_component_array_port_type component_array clock_sink] {
		add_connection $clock/$clk_port;
	}
	
	set return_comp(fsm_pipeline_bridge) [list ports [list avalon_slave [list s1]]];
	
	return [array get return_comp];
}
                                     
proc add_tlb_tcm {clock tcm_name} {
	set components($tcm_name) [list class  altera_avalon_onchip_memory2];
	
	set component_params(allowInSystemMemoryContentEditor) "false";
	set component_params(blockType) "AUTO";
	set component_params(dataWidth) "32";
	set component_params(dualPort) "true";
	set component_params(initMemContent) "true";
	set component_params(initializationFileName) "tlb_tcm";
	set component_params(instanceID) "NONE";
	set component_params(memorySize) "16384";
	set component_params(readDuringWriteMode) "DONT_CARE";
	set component_params(simAllowMRAMContentsFile) "false";
	set component_params(slave1Latency) "1";
	set component_params(slave2Latency) "1";
	set component_params(useNonDefaultInitFile) "false";
	set component_params(useShallowMemBlocks) "false";
	set component_params(writable) "true";
	
	lappend components($tcm_name) parameters [array get component_params];
	lappend components($tcm_name) ports [list avalon_slave [list s1 s2] clock_sink [list clk1 clk2]];
	          
	#add component
	add_component_array components;
	        
	set return_ports($tcm_name) [list ports [list avalon_slave [list s1 s2] clock_sink [list clk1 clk2]]];
        
	return [array get components];
}

proc add_high_peripheral_pipeline_bridge_and_components {peripheral_clock} {
	#components
	set components(led_pio) [list class altera_avalon_pio];
	set component_params(bitClearingEdgeCapReg) "false";
	set component_params(captureEdge) "false";
	set component_params(direction) "Output";
	set component_params(edgeType) "RISING";
	set component_params(generateIRQ) "false";
	set component_params(irqType) "EDGE";
	set component_params(resetValue) "0";
	set component_params(simDoTestBenchWiring) "false";
	set component_params(simDrivenValue) "0";
	set component_params(width) "8";
	lappend components(led_pio) parameters [array get component_params];
	lappend components(led_pio) ports [list clock_sink [list clk] avalon_slave [list s1]];
	array unset component_params;
	
	set bridge_component(high_peripheral_pipeline_bridge) [list class altera_avalon_pipeline_bridge]
	set component_params(dataWidth) "32";
	set component_params(maxBurstSize) "2";
	set component_params(waitrequestPipeline) "true";
	set component_params(burstEnable) "false";
	set component_params(downstreamPipeline) "true";
	set component_params(upstreamPipeline) "true";
	set component_params(enableArbiterlock) "false";
	lappend bridge_component(high_peripheral_pipeline_bridge) parameters [array get component_params];
	array unset component_params;
	lappend bridge_component(high_peripheral_pipeline_bridge) ports [list clock_sink [list clk] avalon_slave [list s1] avalon_master [list m1]];
	                                            
	#connection parameters
	set connection_params(led_pio) [list baseAddress "0x180" arbitrationPriority "1"];
	
	#hack, i know there is only one of each           
	set bridge_master [get_component_ports_of_type bridge_component high_peripheral_pipeline_bridge avalon_master];
	set bridge_clock [get_component_ports_of_type bridge_component high_peripheral_pipeline_bridge clock_sink];
	
	set component_slaves [get_component_array_port_type components avalon_slave];
	set component_clocks [get_component_array_port_type components clock_sink];

	#add components
	add_component_array components; 
	add_component_array bridge_component; 
	
	#connect the clocks
	add_connection $peripheral_clock/$bridge_clock;
	
	foreach clock_port $component_clocks {
		add_connection $peripheral_clock/$clock_port;
	}

	#connect bridge master to component slaves
	foreach avalon_slave $component_slaves {
		set slave [lindex [split $avalon_slave "."] 0];
		add_connection $bridge_master/$avalon_slave;
		
		array set param_array $connection_params($slave);
		
		foreach param [array names param_array] {
			set_parameter $bridge_master/$avalon_slave $param $param_array($param);
		}
		
		array unset param_array; 
	}	
	
	set return_components(high_peripheral_pipeline_bridge) [list ports [list avalon_slave [list s1]]];

	return [array get return_components];	

}

proc add_peripheral_pipeline_bridge_and_components {peripheral_clock} {
	#create array of components and there parameters
	#to be added
	#also define ports for component
	set comp_name dipsw_pio;
	set components($comp_name) [list class altera_avalon_pio]
	set component_params(bitClearingEdgeCapReg) "false";
	set component_params(captureEdge) "true";
	set component_params(direction) "Input";
	set component_params(edgeType) "RISING";
	set component_params(generateIRQ) "true";
	set component_params(irqType0 "EDGE";
	set component_params(resetValue) "0";
	set component_params(simDoTestBenchWiring) "false";
	set component_params(simDrivenValue) "0";
	set component_params(width) "8";
	lappend components($comp_name) ports [list clock_sink [list clk] avalon_slave [list s1] interrupt_sender [list irq]];
	lappend components($comp_name) parameters [array get component_params];
	array unset component_params;
	
	set comp_name button_pio;
	set components($comp_name) [list class altera_avalon_pio]
	set component_params(bitClearingEdgeCapReg) "false";
	set component_params(captureEdge) "true";
	set component_params(direction) "Input";
	set component_params(edgeType) "RISING";
	set component_params(generateIRQ) "true";
	set component_params(irqType) "EDGE";
	set component_params(resetValue) "0";
	set component_params(simDoTestBenchWiring) "false";
	set component_params(simDrivenValue) "0";
	set component_params(width) "4";                       
	lappend components($comp_name) ports [list clock_sink [list clk] avalon_slave [list s1] interrupt_sender [list irq]];
	lappend components($comp_name) parameters [array get component_params];
	array unset component_params;
	
	set comp_name dma_0;
	set components($comp_name) [list class altera_avalon_dma];
	set component_params(allowByteTransactions) "true";
	set component_params(allowDoubleWordTransactions) "true";
	set component_params(allowHalfWordTransactions) "true";
	set component_params(allowQuadWordTransactions) "true";
	set component_params(allowWordTransactions) "true";
	set component_params(bigEndian) "false";
	set component_params(burstEnable) "false";
	set component_params(maxBurstSize) "4";
	set component_params(minimumDmaTransactionRegisterWidth) "13";
	set component_params(useRegistersForFIFO) "false";
	lappend components($comp_name) ports [list clock_sink [list clk] avalon_slave [list control_port_slave] interrupt_sender [list irq] avalon_master [list write_master read_master]]
	lappend components($comp_name) parameters [array get component_params];
	array unset component_params;
	
	set comp_name uart;
	set components($comp_name) [list class altera_avalon_uart]
	set component_params(baud) "115200";
	set component_params(dataBits) "8";
	set component_params(fixedBaud) "false";
	set component_params(parity) "NONE";
	set component_params(simCharStream) "";
	set component_params(simInteractiveInputEnable) "false";
	set component_params(simInteractiveOutputEnable) "false";
	set component_params(simTrueBaud) "false";
	set component_params(stopBits) "1";
	set component_params(useCtsRts) "false";
	set component_params(useEopRegister) "false";
	lappend components($comp_name) ports [list clock_sink [list clk] avalon_slave [list s1] interrupt_sender [list irq]];
	lappend components($comp_name) parameters [array get component_params];
	array unset component_params;
	
	set comp_name jtag_uart;
	set components($comp_name) [list class altera_avalon_jtag_uart]
	set component_params(allowMultipleConnections) "false";
	set component_params(hubInstanceID) "0";
	set component_params(readBufferDepth) "64";
	set component_params(readIRQThreshold) "8";
	set component_params(simInputCharacterStream) "";
	set component_params(simInteractiveOptions) "INTERACTIVE_ASCII_OUTPUT";
	set component_params(useRegistersForReadBuffer) "false";
	set component_params(useRegistersForWriteBuffer) "false";
	set component_params(writeBufferDepth) "64";
	set component_params(writeIRQThreshold) "8";
	lappend components($comp_name) ports [list clock_sink [list clk] avalon_slave [list avalon_jtag_slave] interrupt_sender [list irq]]
	lappend components($comp_name) parameters [array get component_params];
	array unset component_params;
	
	set comp_name peripheral_pipeline_bridge;
	set bridge_component($comp_name) [list class altera_avalon_pipeline_bridge]
	set component_params(dataWidth) "32"
	set component_params(maxBurstSize) "2"
	set component_params(waitrequestPipeline) "true"
	set component_params(burstEnable) "false"
	set component_params(downstreamPipeline) "true"
	set component_params(upstreamPipeline) "true"
	set component_params(enableArbiterlock) "false"
	lappend bridge_component($comp_name) ports [list clock_sink [list clk] avalon_slave [list s1] avalon_master [list m1]]
	lappend bridge_component($comp_name) parameters [array get component_params];
	array unset component_params;
	
	#connection parameters
	set connection_params(jtag_uart) [list baseAddress "0x01c0" arbitrationPriority "1"];
	set connection_params(uart) [list baseAddress "0x0080" arbitrationPriority "1"];
	set connection_params(dipsw_pio) [list baseAddress "0x0100" arbitrationPriority "1"];
	set connection_params(button_pio) [list baseAddress "0x0140" arbitrationPriority "1"];
	set connection_params(timer_1ms) [list baseAddress "0x000" arbitrationPriority "1"];  
	set connection_params(dma_0) [list baseAddress "0x200" arbitrationPriority "1"];
	 
	#get bridge masters and clocks
	set bridge_master [get_component_ports_of_type bridge_component peripheral_pipeline_bridge avalon_master];
	set bridge_clock [get_component_ports_of_type bridge_component peripheral_pipeline_bridge clock_sink];
	
	
	
	set component_slaves [get_component_array_port_type components avalon_slave];
	set component_clocks [get_component_array_port_type components clock_sink];
	
	#add components
	add_component_array components;
	add_component_array bridge_component;
	
	#connect the clocks
	add_connection $peripheral_clock/$bridge_clock;
	
	foreach clock_port $component_clocks {
		add_connection $peripheral_clock/$clock_port;
	}

	#connect bridge master to component slaves
	foreach avalon_slave $component_slaves {
		set slave [lindex [split $avalon_slave "."] 0];
		add_connection $bridge_master/$avalon_slave;
		
		array set param_array $connection_params($slave);
		
		foreach param [array names param_array] {
			set_parameter $bridge_master/$avalon_slave $param $param_array($param);
		}
		
		array unset param_array;
	}	
	
	set return_components(dma_0) [list ports [list avalon_master [list write_master read_master] interrupt_sender [list irq]]];
	set return_components(peripheral_pipeline_bridge) [list ports [list avalon_slave [list s1]]];
	set return_components(uart) [list ports [list interrupt_sender [list irq]]];
	set return_components(jtag_uart) [list ports [list interrupt_sender [list irq]]];
	set return_components(dipsw_pio) [list ports [list interrupt_sender [list irq]]];
	set return_components(button_pio) [list ports [list interrupt_sender [list irq]]];
	
	return [array get return_components];
}

proc add_hp_ddr2 {ref_clock {local_if_drate "Half"}} {
	add_module altmemddr2 ddr2_top
	
	#set params
	set_parameter ddr2_top debug_en "false"
	set_parameter ddr2_top export_debug_port "false"
	set_parameter ddr2_top use_generated_memory_model "true"
	set_parameter ddr2_top dedicated_memory_clk_phase_label "Dedicated memory clock phase:"
	set_parameter ddr2_top mem_if_clk_mhz "150.0"
	set_parameter ddr2_top quartus_project_exists "false"
	
	set_parameter ddr2_top enable_v72_rsu "false"
	
	set_parameter ddr2_top new_variant "true"
	set_parameter ddr2_top mem_if_memtype "DDR2 SDRAM"
	set_parameter ddr2_top pll_ref_clk_mhz "50.0"                                          
	set_parameter ddr2_top mem_if_clk_ps_label "(6667 ps)"
	set_parameter ddr2_top family "Cyclone III"
	set_parameter ddr2_top project_family "Cyclone III"
	set_parameter ddr2_top speed_grade "7"
	set_parameter ddr2_top dedicated_memory_clk_phase "0"
	set_parameter ddr2_top pll_ref_clk_ps_label "(20000 ps)"
	set_parameter ddr2_top mem_if_pchaddr_bit "10"
	set_parameter ddr2_top mem_if_clk_pair_count "2"
	set_parameter ddr2_top vendor "Micron"
	set_parameter ddr2_top chip_or_dimm "Discrete Device"
	set_parameter ddr2_top mem_fmax "333.333"
	set_parameter ddr2_top mem_if_cs_per_dimm "1"
	set_parameter ddr2_top pre_latency_label "Fix read latency at:"
	set_parameter ddr2_top dedicated_memory_clk_en "false"
	set_parameter ddr2_top mem_if_bankaddr_width "2"
	set_parameter ddr2_top mem_if_preset_rlat "0"
	set_parameter ddr2_top post_latency_label "cycles (0 cycles=minimum latency, non-deterministic)"
	set_parameter ddr2_top mem_dyn_deskew_en "false"
	set_parameter ddr2_top mem_if_cs_width "1"
	set_parameter ddr2_top mem_if_rowaddr_width "13"
	set_parameter ddr2_top mem_if_dm_pins_en "Yes"
	set_parameter ddr2_top mem_if_preset "Micron MT47H32M16CC-3"
	set_parameter ddr2_top fast_simulation_en "FAST"
	set_parameter ddr2_top mem_if_coladdr_width "10"
	set_parameter ddr2_top mem_if_dq_per_dqs "8"
	set_parameter ddr2_top mem_if_dwidth "32"
	set_parameter ddr2_top mem_tiha_ps "400"
	set_parameter ddr2_top mem_tdsh_ck "0.2"
	set_parameter ddr2_top mem_if_trfc_ns "105.0"
	set_parameter ddr2_top mem_tqh_ck "0.36"
	set_parameter ddr2_top mem_tisa_ps "400"
	set_parameter ddr2_top mem_tdss_ck "0.2"
	set_parameter ddr2_top mem_if_tinit_us "200.0"
	set_parameter ddr2_top mem_if_trcd_ns "15.0"
	set_parameter ddr2_top mem_if_twtr_ck "3"
	set_parameter ddr2_top mem_tdqss_ck "0.25"
	set_parameter ddr2_top mem_tqhs_ps "340"
	set_parameter ddr2_top mem_tdsa_ps "300"                         
	set_parameter ddr2_top mem_tac_ps "450"
	set_parameter ddr2_top mem_tdha_ps "300"
	set_parameter ddr2_top mem_if_tras_ns "40.0"
	set_parameter ddr2_top mem_if_twr_ns "15.0"
	set_parameter ddr2_top mem_tdqsck_ps "400"
	set_parameter ddr2_top mem_if_trp_ns "15.0"
	set_parameter ddr2_top mem_tdqsq_ps "240"
	set_parameter ddr2_top mem_if_tmrd_ns "6.0"
	set_parameter ddr2_top mem_if_trefi_us "7.8"
	set_parameter ddr2_top mem_tcl "5.0"
	set_parameter ddr2_top mem_tcl_40_fmax "266.667"
	set_parameter ddr2_top mem_odt "50"
	set_parameter ddr2_top mem_dll_en "Yes"
	set_parameter ddr2_top ac_phase "90"
	set_parameter ddr2_top mem_drv_str "Normal"
	set_parameter ddr2_top mem_if_oct_en "false"
	set_parameter ddr2_top input_period "0"
	set_parameter ddr2_top mem_tcl_60_fmax "333.333"
	set_parameter ddr2_top board_skew_ps "20"
	set_parameter ddr2_top mem_if_dqsn_en "false"
	set_parameter ddr2_top dll_external "false"
	set_parameter ddr2_top mem_tcl_15_fmax "533.0"
	set_parameter ddr2_top mem_tcl_30_fmax "200.0"
	set_parameter ddr2_top mem_bl "4"
	set_parameter ddr2_top ac_clk_select "90"
	set_parameter ddr2_top mem_tcl_50_fmax "333.333"
	set_parameter ddr2_top mem_tcl_25_fmax "533.0"
	set_parameter ddr2_top mem_tcl_20_fmax "533.0"
	set_parameter ddr2_top pll_reconfig_ports_en "false"         
	set_parameter ddr2_top mem_btype "Sequential"
	set_parameter ddr2_top ctl_ecc_en "false"
	set_parameter ddr2_top user_refresh_en "false"
	set_parameter ddr2_top local_if_type_avalon "true"
	set_parameter ddr2_top ctl_self_refresh_en "false"
	set_parameter ddr2_top ctl_autopch_en "false"
	set_parameter ddr2_top ctl_powerdn_en "false"
	set_parameter ddr2_top tool_context "SOPC_BUILDER"
	set_parameter ddr2_top mem_srtr "Normal"
	set_parameter ddr2_top mem_mpr_loc "Predefined Pattern"
	set_parameter ddr2_top dss_tinit_rst_us "200.0"
	set_parameter ddr2_top mem_tcl_90_fmax "400.0"
	set_parameter ddr2_top mem_rtt_wr "Dynamic ODT off"
	set_parameter ddr2_top mem_tcl_100_fmax "400.0"
	set_parameter ddr2_top mem_pasr "Full Array"
	set_parameter ddr2_top mem_asrm "Manual SR Reference (SRT)"
	set_parameter ddr2_top mem_mpr_oper "Predefined Pattern"
	set_parameter ddr2_top mem_tcl_80_fmax "400.0"
	set_parameter ddr2_top mem_drv_impedance "RZQ/7"
	set_parameter ddr2_top mem_rtt_nom "ODT Disabled"
	set_parameter ddr2_top mem_tcl_70_fmax "400.0"
	set_parameter ddr2_top mem_wtcl "5.0"
	set_parameter ddr2_top mem_dll_pch "Fast Exit"
	set_parameter ddr2_top mem_atcl "Disabled"

	if {$local_if_drate == "Half"} {
		set_parameter ddr2_top local_if_clk_mhz_label "(75.0 MHz)"
		set_parameter ddr2_top avalon_burst_length "1";
		set_parameter ddr2_top local_if_drate "Half";
		
		set_parameter ddr2_top WIDTH_RATIO "4";
		set_parameter ddr2_top local_if_dwidth_label "128";
	} else {
		set_parameter ddr2_top local_if_clk_mhz_label "(150.0 MHz)"
		set_parameter ddr2_top avalon_burst_length "1";
		set_parameter ddr2_top local_if_drate "Full";
		
		set_parameter ddr2_top WIDTH_RATIO "4";
		set_parameter ddr2_top local_if_dwidth_label "64";
	}
	
	add_connection $ref_clock/ddr2_top.refclk;
	
	set return_comp(ddr2_top) ""
	lappend return_comp(ddr2_top) ports [list avalon_slave [list s1] clock_source [list auxhalf auxfull sysclk]];
}
                               
proc add_cpu {clock {cache_size "_32768"}} {
	#add component
	add_module altera_nios2 cpu
	
	## Module cpu
	set_parameter cpu userDefinedSettings ""
	set_parameter cpu setting_showUnpublishedSettings "false"
	set_parameter cpu setting_showInternalSettings "false"
	set_parameter cpu setting_preciseSlaveAccessErrorException "false"
	set_parameter cpu setting_preciseIllegalMemAccessException "false"
	set_parameter cpu setting_preciseDivisionErrorException "false"
	set_parameter cpu setting_performanceCounter "false"
	set_parameter cpu setting_perfCounterWidth "_32"
	set_parameter cpu setting_illegalMemAccessDetection "false"
	set_parameter cpu setting_illegalInstructionsTrap "false"
	set_parameter cpu setting_fullWaveformSignals "false"
	set_parameter cpu setting_extraExceptionInfo "false"
	set_parameter cpu setting_exportPCB "false"
	set_parameter cpu setting_debugSimGen "false"
	set_parameter cpu setting_clearXBitsLDNonBypass "true"
	set_parameter cpu setting_branchPredictionType "Automatic"
	set_parameter cpu setting_bit31BypassDCache "true"
	set_parameter cpu setting_bhtPtrSz "_8"
	set_parameter cpu setting_bhtIndexPcOnly "false"
	set_parameter cpu setting_avalonDebugPortPresent "false"
	set_parameter cpu setting_alwaysEncrypt "true"
	set_parameter cpu setting_allowFullAddressRange "false"
	set_parameter cpu setting_activateTrace "true"
	set_parameter cpu setting_activateTestEndChecker "false"
	set_parameter cpu setting_activateMonitors "true"
	set_parameter cpu setting_activateModelChecker "false"
	set_parameter cpu setting_HDLSimCachesCleared "true"
	set_parameter cpu setting_HBreakTest "false"
	set_parameter cpu resetSlave "ext_flash.s1"
	set_parameter cpu resetOffset "29360128" 
	set_parameter cpu muldiv_multiplierType "EmbeddedMulFast"
	set_parameter cpu muldiv_divider "false"
	set_parameter cpu mpu_useLimit "false"
	set_parameter cpu mpu_numOfInstRegion "8"
	set_parameter cpu mpu_numOfDataRegion "8"
	set_parameter cpu mpu_minInstRegionSize "_12"
	set_parameter cpu mpu_minDataRegionSize "_12"
	set_parameter cpu mpu_enabled "false"
	set_parameter cpu mmu_uitlbNumEntries "_4"
	set_parameter cpu mmu_udtlbNumEntries "_6"
	set_parameter cpu mmu_tlbPtrSz "_8"
	set_parameter cpu mmu_tlbNumWays "_16"
	set_parameter cpu mmu_processIDNumBits "_8"
	set_parameter cpu mmu_enabled "false"
	set_parameter cpu mmu_autoAssignTlbPtrSz "false"
	set_parameter cpu mmu_TLBMissExcSlave "tlb_tcm.s1"
	set_parameter cpu mmu_TLBMissExcOffset "8192"
	set_parameter cpu impl "Fast"
	
	set_parameter cpu icache_ramBlockType "Automatic"
	set_parameter cpu icache_numTCIM "_1"
	set_parameter cpu icache_burstType "None"
	set_parameter cpu exceptionSlave "ddr2_top.s1"
	set_parameter cpu exceptionOffset "32"
	set_parameter cpu debug_triggerArming "true"
	set_parameter cpu debug_level "Level1"
	set_parameter cpu debug_embeddedPLL "true"
	set_parameter cpu debug_debugReqSignals "false"
	set_parameter cpu debug_OCIOnchipTrace "_128"
	
	set_parameter cpu dcache_ramBlockType "Automatic"
	set_parameter cpu dcache_omitDataMaster "false"
	set_parameter cpu dcache_numTCDM "_1"
	set_parameter cpu dcache_lineSize "_32"
	set_parameter cpu dcache_bursts "false"
	set_parameter cpu cpuReset "false"
	set_parameter cpu breakSlave "cpu.jtag_debug_module"
	set_parameter cpu breakOffset "32"
	
	
	#set_parameter cpu dcache_size "_32768"
	#set_parameter cpu icache_size "_32768"
	set_parameter cpu dcache_size $cache_size
	set_parameter cpu icache_size $cache_size
	
	
	add_connection $clock/cpu.clk;
	
	set return_component(cpu) "";                                                                                
	lappend return_component(cpu) ports [list interrupt_receiver [list d_irq] avalon_master [list instruction_master data_master tightly_coupled_instruction_master_0 tightly_coupled_data_master_0] avalon_slave [list jtag_debug_module]];
	
}

proc change_cpu_type {cpu_name cpu_type} {
	switch -exact $cpu_type {
		MAXIMUM_MMU {
			#Maximum MMU                                   
			puts "NIOS MAXIMUM MMU Setting"
			set_parameter $cpu_name mmu_uitlbNumEntries "_8"
			set_parameter $cpu_name mmu_udtlbNumEntries "_8"
			set_parameter $cpu_name mmu_tlbPtrSz "_10"
			set_parameter $cpu_name mmu_tlbNumWays "_16"
			set_parameter $cpu_name mmu_processIDNumBits "_14"
			set_parameter $cpu_name mmu_enabled "true"
			set_parameter $cpu_name mmu_autoAssignTlbPtrSz "false"
			set_parameter $cpu_name mmu_TLBMissExcSlave "tlb_tcm.s1"
			set_parameter $cpu_name mmu_TLBMissExcOffset "8192"
		}
		DEFAULT_MMU {
			#Default MMU
			puts "NIOS MINIMUM MMU Setting"
			set_parameter $cpu_name mmu_uitlbNumEntries "_4"
			set_parameter $cpu_name mmu_udtlbNumEntries "_6"
			set_parameter $cpu_name mmu_tlbPtrSz "_8"
			set_parameter $cpu_name mmu_tlbNumWays "_8"
			set_parameter $cpu_name mmu_processIDNumBits "_8"
			set_parameter $cpu_name mmu_enabled "true"
			set_parameter $cpu_name mmu_autoAssignTlbPtrSz "false"
			set_parameter $cpu_name mmu_TLBMissExcSlave "tlb_tcm.s1"
			set_parameter $cpu_name mmu_TLBMissExcOffset "8192"
		}
		MINIMUM_MMU {
			#Minimum MMU
			puts "NIOS MINIMUM MMU Setting"
			set_parameter $cpu_name mmu_uitlbNumEntries "_8"
			set_parameter $cpu_name mmu_udtlbNumEntries "_8"
			set_parameter $cpu_name mmu_tlbPtrSz "_10"
			set_parameter $cpu_name mmu_tlbNumWays "_16"
			set_parameter $cpu_name mmu_processIDNumBits "_14"
			set_parameter $cpu_name mmu_enabled "true"
			set_parameter $cpu_name mmu_autoAssignTlbPtrSz "false"
			set_parameter $cpu_name mmu_TLBMissExcSlave "tlb_tcm.s1"
			set_parameter $cpu_name mmu_TLBMissExcOffset "8192"
		}
		NO_MMU {
			# No MMU
			puts "NIOS NO MMU Setting"
			set_parameter $cpu_name mmu_uitlbNumEntries "_4"
			set_parameter $cpu_name mmu_udtlbNumEntries "_6"
			set_parameter $cpu_name mmu_tlbPtrSz "_8"
			set_parameter $cpu_name mmu_tlbNumWays "_16"
			set_parameter $cpu_name mmu_processIDNumBits "_8"
			set_parameter $cpu_name mmu_enabled "false"
			set_parameter $cpu_name mmu_autoAssignTlbPtrSz "false"
			set_parameter $cpu_name mmu_TLBMissExcSlave "tlb_tcm.s1"
			set_parameter $cpu_name mmu_TLBMissExcOffset "8192"
		}
		default {
			# No MMU
			puts "Default NIOS MMU Setting - No MMU"
			set_parameter $cpu_name mmu_uitlbNumEntries "_4"
			set_parameter $cpu_name mmu_udtlbNumEntries "_6"
			set_parameter $cpu_name mmu_tlbPtrSz "_8"
			set_parameter $cpu_name mmu_tlbNumWays "_16"
			set_parameter $cpu_name mmu_processIDNumBits "_8"
			set_parameter $cpu_name mmu_enabled "false"
			set_parameter $cpu_name mmu_autoAssignTlbPtrSz "false"
			set_parameter $cpu_name mmu_TLBMissExcSlave "tlb_tcm.s1"
			set_parameter $cpu_name mmu_TLBMissExcOffset "8192"
		}
	}
}

       

proc add_pipeline_bridge {bridge_name {width 32}} {
	#pipeline bridge
	set pipeline_bridge(class) altera_avalon_pipeline_bridge;
	set component_params(dataWidth) $width;
	set component_params(maxBurstSize) "2";
	set component_params(waitrequestPipeline) "true";
	set component_params(burstEnable) "false";
	set component_params(downstreamPipeline) "true";
	set component_params(upstreamPipeline) "true";
	set component_params(enableArbiterlock) "false";
	set pipeline_bridge(parameters) [array get component_params];
	array unset component_params;
	set pipeline_bridge(ports) [list clock_sink [list clk] avalon_slave [list s1] avalon_master [list m1]];

	array set $bridge_name [array get pipeline_bridge];
	
	add_component $bridge_name;
	
	set component(ports) $pipeline_bridge(ports);
	
	return [array get component];
	
}


proc add_component {component_name} {

	upvar 1 $component_name component;
	#add the component
	
	add_module $component(class) $component_name;       
	
	array set component_params $component(parameters);      
	
	#add parameters
	foreach param [array names component_params] {
		set_parameter $component_name $param $component_params($param);
	}
}
                                                                     

proc add_component_array {component_array_name} {

	upvar 1 $component_array_name components;
	                                   
	foreach component [array names components] {
		array set $component $components($component);
		add_component $component
		array unset $component;
	}
}

proc get_component_array_port_type {component_array_name port_type} {

	upvar 1 $component_array_name components;
                                                    
	
	array set ports [get_component_array_ports components];
	
	if {[lsearch [array names ports] $port_type] >= 0} {
		return $ports($port_type);
	} else {
		return "";
	}
}

proc get_component_ports_of_type {component_array_name component port_type} {

	upvar 1 $component_array_name components;
		
	array set component_ports [get_component_ports_from_component_array components $component];
	
	if {[lsearch [array names component_ports] $port_type] >= 0} {
		
		return $component_ports($port_type);
	} else {
		return "";
	}
}

proc get_component_ports_from_component_array {component_array_name component} {

	upvar 1 $component_array_name components;

	if {[lsearch [array names components] $component] >= 0} {
		array set this_component $components($component);
		
		array set this_component_ports $this_component(ports);
		foreach port_type [array names this_component_ports] {
			set port_type_list "";
			foreach port $this_component_ports($port_type) {
				set full_name $component;
				append full_name ".";
				append full_name $port;
				lappend port_type_list $full_name;
			}
			set this_component_ports($port_type) $port_type_list;
		}
		return [array get this_component_ports];
	} else {
		return "";
	}
}

proc get_component_array_ports {component_array_name} {
	upvar 1 $component_array_name components;
	
	#init port list
	set ports(clock_sink) ""
	set ports(clock_source) ""
	set ports(avalon_master) ""
	set ports(avalon_slave) ""
	set ports(avalon_tristate_slave) ""
	set ports(avalon_tristate_master) ""
	set ports(interrupt_sender) ""
	set ports(avalon_streaming_sink) ""
	set ports(avalon_streaming_source) ""
	set ports(interrupt_receiver) ""     
	
	
	#loop over components
	foreach component [array names components] {
		array set this_component $components($component);

		#get component ports
		array set this_component_ports $this_component(ports);
		
		#loop over ports
		foreach port [array names this_component_ports] {
			if {[lsearch [array names ports] $port] >= 0} {
				foreach local_port $this_component_ports($port) {
					set this_port $component;
					append this_port ".";
					append this_port $local_port;
					lappend ports($port) $this_port;
				}
			} else {
				error "Invalid port type $port";
			}
		}
		array unset this_component;
		array unset this_component_ports;
	}
	
	foreach port_type [array names ports] {
		if {[llength $ports($port_type)] == 0} {
			array unset ports $port_type
		}
	}
	
	return [array get ports];
}  

